#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <string.h>

#include "lookup.h"


/* [ lookup ]
 * Resolve the IP address/hostnames
 */
void
lookup (char *text, char *dsttxt)
{
	char temptext[1024];
	char *tstart,*dtstart;
	
	struct hostent *answer = NULL;
	struct in_addr address;
		
	tstart=text;
	dtstart=dsttxt;
	
	strcpy(temptext,"");
	
	while(*text) {
		// Look for a space or colon.
		if(*text == ' ' || *text == ':') {
			if(IsIpAddr(temptext)) {
				if (inet_aton (temptext, &address)) {
					answer = gethostbyaddr ((char *)&address,sizeof(address),AF_INET);
					if(answer) {
						strcat(temptext," (");
						strcat(temptext,answer->h_name);
						strcat(temptext,")");
					}
				}
			}
			
			strcat(dsttxt,temptext);
			strcpy(temptext,"");
						
			if(*text == ' ') {
				strcat(dsttxt," ");
			} else {
				strcat(dsttxt,":");
			}
			
			text++;
		} else {
			char temp[2];
			temp[0]=*text;temp[1]='\0';
			strcat(temptext,temp);
			text++;
		}
	}
	
	strcat(dsttxt,temptext);

}

/*
 * Return TRUE if the given string is an IP address composed of
 * 4 numbers between 0 and 255 separated by dots.  If the string
 * is an IP address, return the value in *pIp.
 */
static int IsIpAddr(char *z) {
  int a1, a2, a3, a4;
  if( sscanf(z,"%d.%d.%d.%d",&a1,&a2,&a3,&a4)==4
    && a1>=0 && a1<=255
    && a2>=0 && a2<=255
    && a3>=0 && a3<=255
    && a4>=0 && a4<=255
  ){
    return(1);
  }else{
    return(0);
  }
}
